<?php
/**
 * Plugin Name: Fast Approval Payment Gateway with Instant Payouts
 * Plugin URI: https://allcurrencygateway.com/index.php/fast-approval-payment-gateway/
 * Description: Fast Approval High-Risk Merchant Gateway with instant payouts to your USDC wallet.
 * Version: 1.1.3
 * Requires at least: 5.8
 * Tested up to: 6.7
 * WC requires at least: 5.8
 * WC tested up to: 9.4.1
 * Requires PHP: 7.2
 * Author: AllCurrencyGateway
 * Author URI: https://allcurrencygateway.com
 * License: GPLv3
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 */


    // Exit if accessed directly.
    if (!defined('ABSPATH')) {
        exit;
    }

    add_action('before_woocommerce_init', function() {
        if (class_exists(\Automattic\WooCommerce\Utilities\FeaturesUtil::class)) {
            \Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility('custom_order_tables', __FILE__, true);
        }
    });
	
	add_action( 'before_woocommerce_init', function() {
    if ( class_exists( '\Automattic\WooCommerce\Utilities\FeaturesUtil' ) ) {
        \Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'cart_checkout_blocks', __FILE__, true );
    }
} );

/**
 * Enqueue block assets for the gateway.
 */
function allcurrencygateway_enqueue_block_assets() {
    // Fetch all enabled WooCommerce payment gateways
    $allcurrencygateway_available_gateways = WC()->payment_gateways()->get_available_payment_gateways();
    $allcurrencygateway_gateways_data = array();

    foreach ($allcurrencygateway_available_gateways as $gateway_id => $gateway) {
		if (strpos($gateway_id, 'allcurrencygateway-fast-approval-gateway') === 0) {
        $icon_url = !empty($gateway->icon_url) ? esc_url($gateway->icon_url) : '';
        $allcurrencygateway_gateways_data[] = array(
            'id' => sanitize_key($gateway_id),
            'label' => sanitize_text_field($gateway->get_title()),
            'description' => wp_kses_post($gateway->get_description()),
            'icon_url' => sanitize_url($icon_url),
        );
		}
    }

    wp_enqueue_script(
        'allcurrencygateway-block-support',
        plugin_dir_url(__FILE__) . 'assets/js/allcurrencygateway-block-checkout-support.js',
        array('wc-blocks-registry', 'wp-element', 'wp-i18n', 'wp-components', 'wp-blocks', 'wp-editor'),
        filemtime(plugin_dir_path(__FILE__) . 'assets/js/allcurrencygateway-block-checkout-support.js'),
        true
    );

    // Localize script with gateway data
    wp_localize_script(
        'allcurrencygateway-block-support',
        'allcurrencygatewayData',
        $allcurrencygateway_gateways_data
    );
}
add_action('enqueue_block_assets', 'allcurrencygateway_enqueue_block_assets');

/**
 * Enqueue styles for the gateway on checkout page.
 */
function allcurrencygateway_enqueue_styles() {
    if (is_checkout()) {
        wp_enqueue_style(
            'allcurrencygateway-styles',
            plugin_dir_url(__FILE__) . 'assets/css/allcurrencygateway-payment-gateway-styles.css',
            array(),
            filemtime(plugin_dir_path(__FILE__) . 'assets/css/allcurrencygateway-payment-gateway-styles.css')
        );
    }
}
add_action('wp_enqueue_scripts', 'allcurrencygateway_enqueue_styles');

    include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-wert.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-stripe.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-simpleswap.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-rampnetwork.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-mercuryo.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-transak.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-moonpay.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-banxa.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-guardarian.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-particle.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-utorg.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-transfi.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-alchemypay.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-changenow.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-sardine.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-topper.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-unlimit.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-bitnovo.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-robinhood.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-coinbase.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-upi.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-interac.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-simplex.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-swipelux.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-kado.php'); // Include the payment gateway class
	include_once(plugin_dir_path(__FILE__) . 'includes/class-allcurrencygateway-fast-approval-gateway-itez.php'); // Include the payment gateway class

	// Conditional function that check if Checkout page use Checkout Blocks
function allcurrencygateway_is_checkout_block() {
    return WC_Blocks_Utils::has_block_in_page( wc_get_page_id('checkout'), 'woocommerce/checkout' );
}
	
?>